package net.mcreator.puzzle_code.client.gui;

import net.neoforged.neoforge.network.PacketDistributor;

import net.minecraft.world.level.Level;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.network.chat.Component;
import net.minecraft.client.gui.screens.inventory.AbstractContainerScreen;
import net.minecraft.client.gui.components.WidgetSprites;
import net.minecraft.client.gui.components.ImageButton;
import net.minecraft.client.gui.GuiGraphics;

import net.mcreator.puzzle_code.world.inventory.TutorialGadgetGUITutorialMenu;
import net.mcreator.puzzle_code.procedures.ReturnTitleTutorialProcedure;
import net.mcreator.puzzle_code.procedures.ReturnPageTutorialPlusOneProcedure;
import net.mcreator.puzzle_code.procedures.ReturnDescriptionText9Procedure;
import net.mcreator.puzzle_code.procedures.ReturnDescriptionText8Procedure;
import net.mcreator.puzzle_code.procedures.ReturnDescriptionText7Procedure;
import net.mcreator.puzzle_code.procedures.ReturnDescriptionText6Procedure;
import net.mcreator.puzzle_code.procedures.ReturnDescriptionText5Procedure;
import net.mcreator.puzzle_code.procedures.ReturnDescriptionText4Procedure;
import net.mcreator.puzzle_code.procedures.ReturnDescriptionText3Procedure;
import net.mcreator.puzzle_code.procedures.ReturnDescriptionText2Procedure;
import net.mcreator.puzzle_code.procedures.ReturnDescriptionText1Procedure;
import net.mcreator.puzzle_code.procedures.ReturnDescriptionText12Procedure;
import net.mcreator.puzzle_code.procedures.ReturnDescriptionText11Procedure;
import net.mcreator.puzzle_code.procedures.ReturnDescriptionText10Procedure;
import net.mcreator.puzzle_code.network.TutorialGadgetGUITutorialButtonMessage;

import java.util.HashMap;

import com.mojang.blaze3d.systems.RenderSystem;

public class TutorialGadgetGUITutorialScreen extends AbstractContainerScreen<TutorialGadgetGUITutorialMenu> {
	private final static HashMap<String, Object> guistate = TutorialGadgetGUITutorialMenu.guistate;
	private final Level world;
	private final int x, y, z;
	private final Player entity;
	ImageButton imagebutton_left_button;
	ImageButton imagebutton_right_button;
	ImageButton imagebutton_left_button1;

	public TutorialGadgetGUITutorialScreen(TutorialGadgetGUITutorialMenu container, Inventory inventory, Component text) {
		super(container, inventory, text);
		this.world = container.world;
		this.x = container.x;
		this.y = container.y;
		this.z = container.z;
		this.entity = container.entity;
		this.imageWidth = 176;
		this.imageHeight = 167;
	}

	private static final ResourceLocation texture = ResourceLocation.parse("puzzle_code:textures/screens/tutorial_gadget_gui_tutorial.png");

	@Override
	public void render(GuiGraphics guiGraphics, int mouseX, int mouseY, float partialTicks) {
		this.renderBackground(guiGraphics, mouseX, mouseY, partialTicks);
		super.render(guiGraphics, mouseX, mouseY, partialTicks);
		this.renderTooltip(guiGraphics, mouseX, mouseY);
	}

	@Override
	protected void renderBg(GuiGraphics guiGraphics, float partialTicks, int gx, int gy) {
		RenderSystem.setShaderColor(1, 1, 1, 1);
		RenderSystem.enableBlend();
		RenderSystem.defaultBlendFunc();
		guiGraphics.blit(texture, this.leftPos, this.topPos, 0, 0, this.imageWidth, this.imageHeight, this.imageWidth, this.imageHeight);

		guiGraphics.blit(ResourceLocation.parse("puzzle_code:textures/screens/w_divider_1.png"), this.leftPos + 6, this.topPos + 43, 0, 0, 160, 4, 160, 4);

		RenderSystem.disableBlend();
	}

	@Override
	public boolean keyPressed(int key, int b, int c) {
		if (key == 256) {
			this.minecraft.player.closeContainer();
			return true;
		}
		return super.keyPressed(key, b, c);
	}

	@Override
	protected void renderLabels(GuiGraphics guiGraphics, int mouseX, int mouseY) {
		guiGraphics.drawString(this.font,

				ReturnTitleTutorialProcedure.execute(entity), 6, 7, -16737793, false);
		guiGraphics.drawString(this.font,

				ReturnDescriptionText1Procedure.execute(entity), 6, 52, -12829636, false);
		guiGraphics.drawString(this.font,

				ReturnDescriptionText2Procedure.execute(entity), 6, 61, -12829636, false);
		guiGraphics.drawString(this.font,

				ReturnDescriptionText3Procedure.execute(entity), 6, 70, -12829636, false);
		guiGraphics.drawString(this.font,

				ReturnDescriptionText4Procedure.execute(entity), 6, 79, -12829636, false);
		guiGraphics.drawString(this.font,

				ReturnDescriptionText5Procedure.execute(entity), 6, 88, -12829636, false);
		guiGraphics.drawString(this.font,

				ReturnDescriptionText6Procedure.execute(entity), 6, 97, -12829636, false);
		guiGraphics.drawString(this.font,

				ReturnDescriptionText7Procedure.execute(entity), 6, 106, -12829636, false);
		guiGraphics.drawString(this.font,

				ReturnDescriptionText8Procedure.execute(entity), 6, 115, -12829636, false);
		guiGraphics.drawString(this.font,

				ReturnDescriptionText9Procedure.execute(entity), 6, 124, -12829636, false);
		guiGraphics.drawString(this.font,

				ReturnDescriptionText10Procedure.execute(entity), 6, 133, -12829636, false);
		guiGraphics.drawString(this.font,

				ReturnDescriptionText11Procedure.execute(entity), 6, 142, -12829636, false);
		guiGraphics.drawString(this.font,

				ReturnDescriptionText12Procedure.execute(entity), 6, 151, -12829636, false);
		guiGraphics.drawString(this.font,

				ReturnPageTutorialPlusOneProcedure.execute(entity), 56, 25, -12829636, false);
	}

	@Override
	public void init() {
		super.init();
		imagebutton_left_button = new ImageButton(this.leftPos + 6, this.topPos + 21, 20, 20,
				new WidgetSprites(ResourceLocation.parse("puzzle_code:textures/screens/left_button.png"), ResourceLocation.parse("puzzle_code:textures/screens/left_button_highlight.png")), e -> {
					if (true) {
						PacketDistributor.sendToServer(new TutorialGadgetGUITutorialButtonMessage(0, x, y, z));
						TutorialGadgetGUITutorialButtonMessage.handleButtonAction(entity, 0, x, y, z);
					}
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_left_button", imagebutton_left_button);
		this.addRenderableWidget(imagebutton_left_button);
		imagebutton_right_button = new ImageButton(this.leftPos + 29, this.topPos + 21, 20, 20,
				new WidgetSprites(ResourceLocation.parse("puzzle_code:textures/screens/right_button.png"), ResourceLocation.parse("puzzle_code:textures/screens/right_button_highlight.png")), e -> {
					if (true) {
						PacketDistributor.sendToServer(new TutorialGadgetGUITutorialButtonMessage(1, x, y, z));
						TutorialGadgetGUITutorialButtonMessage.handleButtonAction(entity, 1, x, y, z);
					}
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_right_button", imagebutton_right_button);
		this.addRenderableWidget(imagebutton_right_button);
		imagebutton_left_button1 = new ImageButton(this.leftPos + -21, this.topPos + 3, 20, 20,
				new WidgetSprites(ResourceLocation.parse("puzzle_code:textures/screens/left_button.png"), ResourceLocation.parse("puzzle_code:textures/screens/left_button_highlight.png")), e -> {
					if (true) {
						PacketDistributor.sendToServer(new TutorialGadgetGUITutorialButtonMessage(2, x, y, z));
						TutorialGadgetGUITutorialButtonMessage.handleButtonAction(entity, 2, x, y, z);
					}
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_left_button1", imagebutton_left_button1);
		this.addRenderableWidget(imagebutton_left_button1);
	}
}
